package com.cpop.clockin.business.controller;

import com.cpop.core.base.R;
import com.mybatisflex.core.paginate.Page;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import com.cpop.clockin.business.entity.Classes;
import com.cpop.clockin.business.service.ClassesService;
import org.springframework.web.bind.annotation.RestController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import java.io.Serializable;
import java.util.List;

/**
 * 打卡班次表 控制层。
 *
 * @author Yxz
 * @since 2024-01-23
 */
@RestController
@Api(tags = "打卡班次表接口")
@RequestMapping("/backstage/classes")
public class ClassesController {

    @Autowired
    private ClassesService classesService;

    /**
     * 添加打卡班次表。
     *
     * @param classes 打卡班次表
     * @return {@code true} 添加成功，{@code false} 添加失败
     */
    @PostMapping("/save")
    @ApiOperation("保存打卡班次表")
    public R<Void> save(@RequestBody @ApiParam("打卡班次表") Classes classes) {
        classesService.save(classes);
        return R.ok();
    }

    /**
     * 根据主键删除打卡班次表。
     *
     * @param id 主键
     * @return {@code true} 删除成功，{@code false} 删除失败
     */
    @DeleteMapping("/remove/{id}")
    @ApiOperation("根据主键删除打卡班次表")
    public R<Void> remove(@PathVariable @ApiParam("打卡班次表主键") Serializable id) {
        classesService.removeById(id);
        return R.ok();
    }

    /**
     * 根据主键更新打卡班次表。
     *
     * @param classes 打卡班次表
     * @return {@code true} 更新成功，{@code false} 更新失败
     */
    @PutMapping("/update")
    @ApiOperation("根据主键更新打卡班次表")
    public R<Void> update(@RequestBody @ApiParam("打卡班次表主键") Classes classes) {
        classesService.updateById(classes);
        return R.ok();
    }

    /**
     * 查询所有打卡班次表。
     *
     * @return 所有数据
     */
    @GetMapping("/list")
    @ApiOperation("查询所有打卡班次表")
    public R<List<Classes>> list() {
        return R.ok(classesService.list());
    }

    /**
     * 根据打卡班次表主键获取详细信息。
     *
     * @param id 打卡班次表主键
     * @return 打卡班次表详情
     */
    @GetMapping("/getInfo/{id}")
    @ApiOperation("根据主键获取打卡班次表")
    public R<Classes> getInfo(@PathVariable @ApiParam("打卡班次表主键") Serializable id) {
        return R.ok(classesService.getById(id));
    }

    /**
     * 分页查询打卡班次表。
     *
     * @param page 分页对象
     * @return 分页对象
     */
    @GetMapping("/page")
    @ApiOperation("分页查询打卡班次表")
    public R<Page<Classes>> page(@ApiParam("分页信息") Page<Classes> page) {
        return R.ok(classesService.page(page));
    }

}
